/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.FacadeCosmos;

import com.cosmodas.EntCosmos.DetalleFactura;

import java.util.ArrayList;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 * @author obper
 */
@Stateless
public class DetalleFacturaFacade extends AbstractFacade<DetalleFactura> implements DetalleFacturaFacadeLocal {

    @PersistenceContext(unitName = "wcosmodasPersistent")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public DetalleFacturaFacade() {
        super(DetalleFactura.class);
    }

    @Override
    public List<DetalleFactura> obtenerFacturas(String facturaCodigo, String facturaSerie) {

        List<DetalleFactura> rs = new ArrayList<>();

        Query q = em.createNativeQuery("select * from detalle_factura where factura_codigo = ? and factura_serie = ?", DetalleFactura.class);
        q.setParameter(1,facturaCodigo);
        q.setParameter(2, facturaSerie);

        if(q.getResultList().isEmpty()){

             q = em.createNativeQuery("select * from hdetalle_factura where factura_codigo = ? and factura_serie = ?", DetalleFactura.class);
            q.setParameter(1,facturaCodigo);
            q.setParameter(2, facturaSerie);
        }

        rs.addAll(q.getResultList());

        return rs;
    }

    @Override
    public void guardarFactura(DetalleFactura detFactura) {
        em.createNativeQuery("{CALL ingresa_detalles(?, ?, ?, ?, ?, ?, ?)}")
                .setParameter(1, detFactura.getDetalleFacturaPK().getFacturaSerie())
                .setParameter(2, detFactura.getDetalleFacturaPK().getFacturaCodigo())
                .setParameter(3, detFactura.getDetalleFacturaPK().getProductoCodigo())
                .setParameter(4, detFactura.getDetalleFacturaPK().getDetalleFacturaOferta())
                .setParameter(5, detFactura.getDetalleFacturaCantidad())
                .setParameter(6, detFactura.getDetalleFacturaConDescuento())
                .setParameter(7, detFactura.getDetalleFacturaSinDescuento()).executeUpdate();
    }

    @Override
    public void descargarProductos(String productoCodigo, String ofertaCodigo, String sucursalCodigo, Integer cantidad) {
        StringBuilder sql = new StringBuilder("call restas_inventario_facturacion(?,?,?,?)");
        Query q = em.createNativeQuery(sql.toString());
        q.setParameter(1, productoCodigo);
        q.setParameter(2, ofertaCodigo);
        q.setParameter(3, sucursalCodigo);
        q.setParameter(4, cantidad);
        q.executeUpdate();

    }

    @Override
    public void descargarPremios(String premioCodigo, String salaCodigo) {
        StringBuilder sql = new StringBuilder("CALL descarga_articulo_sala(?,?)");
        Query q = em.createNativeQuery(sql.toString());
        q.setParameter(1, premioCodigo);
        q.setParameter(2, salaCodigo);
        q.executeUpdate();

    }

}
